!******************************************************!
!  __________________________________________________  !
! |                                                  | !
! |   Filename: Main.f90                             | !
! |                                                  | !
! |   Mon, Mar 09nd, 2020                            | !
! |                                                  | !
! |   Author: X.Y. Liu                               | !
! |                                                  | !
! |   Please refer to the README for modification    | ! 
! |                                                  | !                          
! |__________________________________________________| !
!______________________________________________________!


program Main

  !!! Step 0: Declare a variable of the type Diag_Par
  use PairDiag
  implicit none
  type(Diag_Par):: P1
  integer(kind=8):: i, j
  real(kind=8):: t1, t2
  call cpu_time(t1)

  !!! Step 1: Initialize the input part
  !!! Orbit and Pairs
  P1%Orbit = 20
  P1%Pairs = 10

  !!! SPE
  do i=1, P1%Orbit
    P1%SPE(i) = i
  end do

  !!! P_F
  do i=1, P1%Orbit
    do j=1, P1%Orbit
      P1%P_F(i, j) = -0.4
    end do
  end do

  !!! Step 2: Call the subroutine
  call Diag_Solver(P1)

  !!! Step 3: Use the output part
  write(*, *) "Energy_Ground  :", P1%Energy_Ground
  write(*, *) "Monopole_Min   :", P1%Monopole_Min
  write(*, *) "Occupation numbers  :"
  do i=1, P1%Orbit
    write(*, *) i, P1%N_Occup(i)
  end do

  call cpu_time(t2)
  write(*, *) "CPU Time : ", t2-t1

  stop

end program Main
